
local DPS_TOOLTIP_DISPLAY = "|cffeda55fClick|r to reset DPS"

--[[local L = GetLocale()
if L == "frFR" then
	DPS_TOOLTIP_DISPLAY = 
end]]

local DPS = _G.CreateFrame("Frame", "StatBlock_DPS")
DPS.obj = _G.LibStub("LibDataBroker-1.1"):NewDataObject("DPS")
DPS.obj.label = "DPS"
DPS.obj.text = "0.0"
_G.LibStub("AceTimer-3.0"):Embed(DPS)
local fmt = string.format

DPS:RegisterEvent("PLAYER_LOGIN")
DPS:RegisterEvent("PLAYER_REGEN_DISABLED")
DPS:RegisterEvent("PLAYER_REGEN_ENABLED")
DPS:SetScript("OnEvent", function(_, event, ...)
	DPS[event](DPS, ...)
end)

local pId
local petId
local GetTime = GetTime

local myDamage = 0
local combatDuration = 0
local combatStartTime = 0
local combatEndTime = 0
local timer = nil

function DPS:PLAYER_LOGIN()
	pId = UnitGUID("player")
	petId = UnitGUID("pet") or "0x0"
	DPS.PLAYER_LOGIN = nil
end

local txt = "%.1f"
function DPS:UpdateBlock()
	combatDuration = GetTime() - combatStartTime
	DPS.obj.text = fmt(txt, myDamage / combatDuration)
end

local events = {
	SWING_DAMAGE = true,
	RANGE_DAMAGE = true,
	SPELL_DAMAGE = true,
	SPELL_PERIODIC_DAMAGE = true,
	DAMAGE_SHIELD = true,
	DAMAGE_SPLIT = true,
}
function DPS:COMBAT_LOG_EVENT_UNFILTERED(_, eventType, Id, _, _, _, _, _, spellID, _, _, damage)
	if not events[eventType] then return end

	if Id == pId or Id == petId then
		if eventType == "SWING_DAMAGE" then
			damage = spellID
		end
		myDamage = myDamage + damage
	end
end

function DPS:PLAYER_REGEN_DISABLED()
	DPS:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	combatStartTime = GetTime()
	myDamage = 0
	timer = self:ScheduleRepeatingTimer("UpdateBlock", 0.2)
end

function DPS:PLAYER_REGEN_ENABLED()
	DPS:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	combatEndTime = GetTime()
	combatDuration = combatEndTime - combatStartTime

	self:UpdateBlock()
	self:CancelTimer(timer, true)
end

function DPS.obj.OnTooltipShow()
	GameTooltip:AddLine(DPS_TOOLTIP_DISPLAY)
end

function DPS.obj.OnClick()
	combatStartTime = GetTime()
	combatEndTime = 0
	combatDuration = 0
	myDamage = 0
	DPS.obj.text = "0.0"
end
